## vowpal-wabbit 4.1+20100420

=== Makefile ===
COMPILER = g++
LIBS = -l boost_program_options -l pthread -l z
BOOST_INCLUDE = /usr/local/boost/include/boost-1_34_1
BOOST_LIBRARY = /usr/local/boost/lib

ARCH = -march=nocona

# for normal fast execution.
FLAGS = -Wall $(ARCH) -ffast-math -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -O3

# for parallelization
#FLAGS = -Wall $(ARCH) -ffast-math -Wno-strict-aliasing -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -O3 -fopenmp

# for profiling
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -pg -g

# for valgrind
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -g -O0

BINARIES = vw
MANPAGES = vw.1

all:	$(BINARIES) $(MANPAGES)

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

vw.o:	 parse_example.h  parse_regressor.h  parse_args.h  parser.h

offset_tree.o:	parse_example.h parse_regressor.h parse_args.h parser.h

parse_args.o:	 parse_regressor.h  parse_example.h  io.h  comp_io.h gd.h

parse_example.o:  io.h  comp_io.h  parse_example.cc  parser.h

sender.o: parse_example.h

cache.o:	 parser.h

sparse_dense.o:	 parse_example.h

gd.o:	 parse_example.h

%.o:	 %.cc  %.h
	$(COMPILER) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(COMPILER) $(FLAGS) -c $< -o $@

vw: hash.o  global_data.o delay_ring.o message_relay.o io.o parse_regressor.o  parse_primitives.o unique_sort.o cache.o simple_label.o parse_example.o multisource.o sparse_dense.o  network.o parse_args.o  gd.o noop.o parser.o vw.o loss_functions.o sender.o main.o
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)

offset_tree: 	hash.o io.o parse_regressor.o parse_primitives.o cache.o sparse_dense.o parse_example.o parse_args.o gd.o parser.o offset_tree.o loss_functions.o
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)


test: vw vw-train vw-test
	@echo $(UNAME)

vw-train: vw
	@echo "TEST: vw training ..."
	@rm -f test/train.dat.cache
	@./vw -b 17 -l 20 --initial_t 128000 \
	--power_t 1 -f test/t_r_temp -c --passes 2 -d test/train.dat --compressed

vw-test: vw-train
	@echo
	@echo "TEST: vw test only ..."
	@cat test/test.dat | ./vw -t -i test/t_r_temp -p test/t_p_out

install: vw
	cp $(BINARIES) ~/bin

clean:
	rm -f  *.o $(BINARIES) *~ $(MANPAGES)

=== debian/changelog ===
vowpal-wabbit (4.1+20100420-1) unstable; urgency=low

  * Initial release (Closes: #576956)
  * Includes upstream changes after 4.1 adopted by upstream (e.g. use of
    help2man for building a manpage)

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 08 Apr 2010 14:35:16 -0400

=== debian/control ===
Source: vowpal-wabbit
Section: science
Priority: optional
Maintainer: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~), libboost-program-options-dev, help2man, zlib1g-dev
Standards-Version: 3.8.4
Homepage: http://hunch.net/~vw/
Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git


Package: vowpal-wabbit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and scalable online learning algorithm
 Vowpal Wabbit is a fast online learning algorithm.  It features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh  $@

override_dh_auto_install:
	# do nothing -- make install is using ~/bin

override_dh_auto_build:
	# provide custom FLAGS to build taking into account CFLAGS in the
	# environment, which are set for noopt now in dpkg-buildpackage.
	# See #544844 for more information on C*FLAGS-ignorance of dh
	make FLAGS="-ffast-math -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 $(CFLAGS)" \
		 BOOST_LIBRARY=/usr/lib

=== debian/watch ===
version=3
http://github.com/JohnLangford/vowpal_wabbit/downloads .*tarball/([\d\.a-z]+)

## vowpal-wabbit 5.0

=== Makefile ===
COMPILER = g++
LIBS = -l boost_program_options -l pthread -l z
#LIBS = -l boost_program_options-gcc34 -l pthread -l z
BOOST_INCLUDE = /usr/local/include
BOOST_LIBRARY = /usr/local/lib

ARCH = -march=native
OPTIM_FLAGS = -O3 -fomit-frame-pointer -ffast-math -fno-strict-aliasing

# for normal fast execution.
FLAGS = -Wall $(ARCH) $(OPTIM_FLAGS) -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE)

# for parallelization
#FLAGS = -Wall $(ARCH) -ffast-math -Wno-strict-aliasing -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -O3 -fopenmp

# for profiling
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -pg -g

# for valgrind
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -g -O0

BINARIES = vw
MANPAGES = vw.1

#all:	$(BINARIES) $(MANPAGES)
all:	$(BINARIES)

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

vw.o:	 parse_example.h  parse_regressor.h  parse_args.h  parser.h

offset_tree.o:	parse_example.h parse_regressor.h parse_args.h parser.h

parse_args.o:	 parse_regressor.h  parse_example.h  io.h  comp_io.h gd.h

parse_example.o:  io.h  comp_io.h  parse_example.cc  parser.h

sender.o: parse_example.h

cache.o:	 parser.h

sparse_dense.o:	 parse_example.h

gd.o:	 parse_example.h

%.o:	 %.cc  %.h
	$(COMPILER) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(COMPILER) $(FLAGS) -c $< -o $@

vw: hash.o  global_data.o delay_ring.o message_relay.o io.o parse_regressor.o  parse_primitives.o unique_sort.o cache.o simple_label.o parse_example.o multisource.o sparse_dense.o  network.o parse_args.o gd.o lda.o cg.o noop.o parser.o vw.o loss_functions.o sender.o main.o
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)

active_interactor:	active_interactor.cc
	$(COMPILER) $(FLAGS) -o $@ $+

offset_tree: 	hash.o io.o parse_regressor.o parse_primitives.o cache.o sparse_dense.o parse_example.o parse_args.o gd.o parser.o offset_tree.o loss_functions.o
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)

.FORCE:

test: .FORCE
	@echo "vw running test-suite..."
	@(cd test && ./RunTests)

install: vw
	cp $(BINARIES) ~/bin

clean:
	rm -f  *.o $(BINARIES) *~ $(MANPAGES)

=== debian/changelog ===
vowpal-wabbit (5.0-1ubuntu1) natty; urgency=low

  * debian/patches/arm_alignment_fault.patch: Work around an ARM
    alignment trap caused by accessing unaligned float values.
    Thanks to Nicolas Pitre for suggesting the trick of casting
    to a packed struct containing a single float value.
    Fixes armel FTBFS (LP: #719305)

 -- Jani Monoses <jani@ubuntu.com>  Tue, 15 Feb 2011 21:57:50 +0200

vowpal-wabbit (5.0-1) unstable; urgency=low

  * New upstream release
  * DEP-5 copyright file
  * Boosted policy to 3.9.1 -- removed reference to BSD-3 file from copyright
  * Explicitly build vw.1 target

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 05 Dec 2010 09:50:55 -0500

=== debian/control ===
Source: vowpal-wabbit
Section: science
Priority: optional
Maintainer: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~), libboost-program-options-dev, help2man, zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://hunch.net/~vw/
Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git


Package: vowpal-wabbit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and scalable online machine learning algorithm
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing

=== debian/rules ===
--- 
+++ 
@@ -12,4 +12,4 @@
 	# environment, which are set for noopt now in dpkg-buildpackage.
 	# See #544844 for more information on C*FLAGS-ignorance of dh
 	make FLAGS="-ffast-math -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 $(CFLAGS)" \
-		 BOOST_LIBRARY=/usr/lib
+		 BOOST_LIBRARY=/usr/lib all vw.1

## vowpal-wabbit 5.1+83

=== Makefile ===
--- 
+++ 
@@ -4,11 +4,12 @@
 BOOST_INCLUDE = /usr/local/include
 BOOST_LIBRARY = /usr/local/lib
 
-ARCH = -march=native
-OPTIM_FLAGS = -O3 -fomit-frame-pointer -ffast-math -fno-strict-aliasing
+ARCH = -march=nocona
+OPTIM_FLAGS = -O3 -fomit-frame-pointer -ffast-math -fno-strict-aliasing 
+WARN_FLAGS = -Wall #-Werror 
 
 # for normal fast execution.
-FLAGS = -Wall $(ARCH) $(OPTIM_FLAGS) -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE)
+FLAGS = $(ARCH) $(WARN_FLAGS) $(OPTIM_FLAGS) -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) #-DVW_LDA_NO_SSE
 
 # for parallelization
 #FLAGS = -Wall $(ARCH) -ffast-math -Wno-strict-aliasing -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -O3 -fopenmp
@@ -19,7 +20,7 @@
 # for valgrind
 #FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -g -O0
 
-BINARIES = vw
+BINARIES = vw allreduce_master active_interactor lda
 MANPAGES = vw.1
 
 #all:	$(BINARIES) $(MANPAGES)
@@ -50,7 +51,13 @@
 %.o:	 %.cc
 	$(COMPILER) $(FLAGS) -c $< -o $@
 
-vw: hash.o  global_data.o delay_ring.o message_relay.o io.o parse_regressor.o  parse_primitives.o unique_sort.o cache.o simple_label.o parse_example.o multisource.o sparse_dense.o  network.o parse_args.o gd.o lda.o cg.o noop.o parser.o vw.o loss_functions.o sender.o main.o
+allreduce_master: allreduce_master.o
+	$(COMPILER) $(FLAGS) -o $@ $+ 
+
+vw: hash.o  global_data.o delay_ring.o message_relay.o io.o parse_regressor.o  parse_primitives.o unique_sort.o cache.o simple_label.o parse_example.o multisource.o sparse_dense.o  network.o parse_args.o gd.o allreduce.o cg.o noop.o parser.o vw.o loss_functions.o sender.o main.o
+	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)
+
+lda: hash.o  global_data.o delay_ring.o message_relay.o io.o parse_regressor.o  parse_primitives.o unique_sort.o cache.o simple_label.o parse_example.o multisource.o sparse_dense.o  network.o parse_args.o gd.o lda_core.o noop.o parser.o loss_functions.o sender.o lda.o
 	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)
 
 active_interactor:	active_interactor.cc
@@ -63,10 +70,10 @@
 
 test: .FORCE
 	@echo "vw running test-suite..."
-	@(cd test && ./RunTests)
+	@(cd test && ./RunTests ../vw ../lda)
 
 install: vw
-	cp $(BINARIES) ~/bin
+	cp $(BINARIES) /usr/local/bin
 
 clean:
 	rm -f  *.o $(BINARIES) *~ $(MANPAGES)

## vowpal-wabbit 5.1+83-gffab10a

=== debian/changelog ===
vowpal-wabbit (5.1+83-gffab10a-1) unstable; urgency=low

  * Fresh upstream snapshot addressing LDA tests errors on 32bit
  * Boosted policy to 3.9.2 -- no changes due

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 06 Jul 2011 18:18:26 -0400

vowpal-wabbit (5.1+47-g3c756c1-1) unstable; urgency=low

  * Fresh upstream snapshot
  * Make failed tests verbose and allow some fuzz

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 03 Jun 2011 14:54:04 -0400

vowpal-wabbit (5.1-1) UNRELEASED; urgency=low

  * New upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 15 May 2011 18:48:57 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 7.0.50~), libboost-program-options-dev, help2man, zlib1g-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://hunch.net/~vw/
 Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
 Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git

=== debian/rules ===
--- 
+++ 
@@ -12,4 +12,12 @@
 	# environment, which are set for noopt now in dpkg-buildpackage.
 	# See #544844 for more information on C*FLAGS-ignorance of dh
 	make FLAGS="-ffast-math -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 $(CFLAGS)" \
-		 BOOST_LIBRARY=/usr/lib all vw.1
+		 BOOST_INCLUDE=/usr/include BOOST_LIBRARY=/usr/lib all vw.1
+
+override_dh_auto_test:
+	: # I: run tests providing options for verbose output on failures
+	cd test && ./RunTests -c -d -f
+
+override_dh_auto_clean:
+	dh_auto_clean
+	-rm -f test/*.predict test/*.tmp

## vowpal-wabbit 6.1

=== Makefile ===
COMPILER = g++
UNAME := $(shell uname)

ifeq ($(UNAME), FreeBSD)
LIBS = -l boost_program_options	-l pthread -l z -l compat
BOOST_INCLUDE = /usr/local/include
BOOST_LIBRARY = /usr/local/lib
else
LIBS = -l boost_program_options -l pthread -l z
BOOST_INCLUDE = /usr/include
BOOST_LIBRARY = /usr/local/lib
endif

ARCH = $(shell test `g++ -v 2>&1 | tail -1 | cut -d ' ' -f 3 | cut -d '.' -f 1,2` \< 4.3 && echo -march=nocona || echo -march=native)

#LIBS = -l boost_program_options-gcc34 -l pthread -l z

OPTIM_FLAGS = -O3 -fomit-frame-pointer -ffast-math -fno-strict-aliasing
ifeq ($(UNAME), FreeBSD)
WARN_FLAGS = -Wall
else
WARN_FLAGS = -Wall -pedantic
endif

# for normal fast execution.
FLAGS = $(ARCH) $(WARN_FLAGS) $(OPTIM_FLAGS) -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) #-DVW_LDA_NO_SSE

# for parallelization
#FLAGS = -Wall $(ARCH) -ffast-math -Wno-strict-aliasing -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -O3 -fopenmp

# for profiling
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -pg -g

# for valgrind
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -g -O0

BINARIES = vw active_interactor
MANPAGES = vw.1

#all:	$(BINARIES) $(MANPAGES)
all:	depend $(BINARIES)

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

depend:	*.cc
	gcc -MM *.cc > depend

-include depend

%.o:	 %.cc  %.h
	$(COMPILER) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(COMPILER) $(FLAGS) -c $< -o $@

export

spanning_tree: 
	cd cluster; $(MAKE); cd ..

vw: hash.o  global_data.o io.o parse_regressor.o  parse_primitives.o unique_sort.o cache.o simple_label.o parse_example.o sparse_dense.o  network.o parse_args.o allreduce.o accumulate.o gd.o lda_core.o gd_mf.o bfgs.o noop.o parser.o vw.o loss_functions.o sender.o main.o
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)

active_interactor:	active_interactor.cc
	$(COMPILER) $(FLAGS) -o $@ $+

offset_tree: 	hash.o io.o parse_regressor.o parse_primitives.o cache.o sparse_dense.o parse_example.o parse_args.o gd.o parser.o offset_tree.o loss_functions.o
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -o $@ $+ $(LIBS)

.FORCE:

test: .FORCE
	@echo "vw running test-suite..."
	@(cd test && ./RunTests -f -E 0.001 ../vw ../vw)

install: $(BINARIES)
	cp $(BINARIES) /usr/local/bin; cd cluster; $(MAKE) install

clean:
	rm -f  *.o $(BINARIES) *~ $(MANPAGES); cd cluster; $(MAKE) clean; cd ..

=== debian/changelog ===
vowpal-wabbit (6.1-1build1) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:44 +0100

vowpal-wabbit (6.1-1) unstable; urgency=low

  * New upstream release
  * debian/copyright -- dep5
  * debian/patches/fix-ftbfs-with-gcc-4.7 -- refreshed
  * debian/watch -- adjusted for github changes
  * debian/rules -- remove depend upon clean
  * debian/vowpal-wabbit.examples -- no cluster_command any longer 

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 29 Jun 2012 00:13:56 -0400

vowpal-wabbit (5.1+83-gffab10a-2) unstable; urgency=low

  [ Cyril Brulebois ]
  * Fix FTBFS with gcc 4.7 by fixing a bunch of missing includes (Closes: #667412).

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 04 Apr 2012 13:14:53 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: vowpal-wabbit
 Section: science
 Priority: optional
-Maintainer: Yaroslav Halchenko <debian@onerussian.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 7.0.50~), libboost-program-options-dev, help2man, zlib1g-dev
 Standards-Version: 3.9.2
 Homepage: http://hunch.net/~vw/

=== debian/rules ===
--- 
+++ 
@@ -20,4 +20,4 @@
 
 override_dh_auto_clean:
 	dh_auto_clean
-	-rm -f test/*.predict test/*.tmp
+	-rm -f test/*.predict test/*.tmp depend

## vowpal-wabbit 7.3

=== Makefile ===
COMPILER = g++
UNAME := $(shell uname)

LIBS = -l boost_program_options -l pthread -l z
BOOST_INCLUDE = /usr/include
ifeq ($(UNAME), FreeBSD)
LIBS = -l boost_program_options	-l pthread -l z -l compat
BOOST_INCLUDE = /usr/local/include
endif
ifeq "CYGWIN" "$(findstring CYGWIN,$(UNAME))"
LIBS = -l boost_program_options-mt -l pthread -l z
BOOST_INCLUDE = /usr/include
endif
ifeq ($(UNAME), Darwin)
LIBS = -lboost_program_options-mt -lboost_serialization-mt -l pthread -l z
BOOST_INCLUDE = /usr/local/include
endif

BOOST_LIBRARY = /usr/local/lib

ARCH = $(shell test `g++ -v 2>&1 | tail -1 | cut -d ' ' -f 3 | cut -d '.' -f 1,2` \< 4.3 && echo -march=nocona || echo -march=native)

#LIBS = -l boost_program_options-gcc34 -l pthread -l z

OPTIM_FLAGS = -O3 -fomit-frame-pointer -fno-strict-aliasing -ffast-math #uncomment for speed, comment for testability
ifeq ($(UNAME), FreeBSD)

WARN_FLAGS = -Wall
else
WARN_FLAGS = -Wall -pedantic
endif

# for normal fast execution.
FLAGS = $(ARCH) $(WARN_FLAGS) $(OPTIM_FLAGS) -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) #-DVW_LDA_NO_SSE

# for profiling
#FLAGS = $(ARCH) $(WARN_FLAGS) -O3 -fno-strict-aliasing -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -pg #-DVW_LDA_NO_SSE

# for valgrind
#FLAGS = $(ARCH) $(WARN_FLAGS) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -g -O0

# for valgrind profiling: run 'valgrind --tool=callgrind PROGRAM' then 'callgrind_annotate --tree=both --inclusive=yes'
#FLAGS = -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 -I $(BOOST_INCLUDE) -g -O3 -fomit-frame-pointer -ffast-math -fno-strict-aliasing

BINARIES = vw active_interactor
MANPAGES = vw.1

all:	vw spanning_tree library_example

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

export

spanning_tree: 
	cd cluster; $(MAKE)

vw:
	cd vowpalwabbit; $(MAKE) things

active_interactor:
	cd vowpalwabbit; $(MAKE)

library_example: vw
	cd library; $(MAKE)

.FORCE:

test: .FORCE
	@echo "vw running test-suite..."
	(cd test && ./RunTests -d -fe -E 0.001 ../vowpalwabbit/vw ../vowpalwabbit/vw)

install: $(BINARIES)
	cd vowpalwabbit; cp $(BINARIES) /usr/local/bin; cd ../cluster; $(MAKE) install

clean:
	cd vowpalwabbit; $(MAKE) clean; cd ../cluster; $(MAKE) clean

=== cluster/Makefile ===
all:	spanning_tree

%.o:	 %.cc  %.h
	$(COMPILER) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(COMPILER) $(FLAGS) -c $< -o $@

spanning_tree: spanning_tree.o
	$(COMPILER) $(FLAGS) -o $@ $+ 

install: spanning_tree
	cp spanning_tree /usr/local/bin

clean:
	rm -f  *.o $(BINARIES) *~ $(MANPAGES)

=== library/Makefile ===
BOOST_PROGRAM_OPTIONS = boost_program_options
ifeq ($(UNAME), FreeBSD)
BOOST_PROGRAM_OPTIONS = boost_program_options
endif
ifeq "CYGWIN" "$(findstring CYGWIN,$(UNAME))"
BOOST_PROGRAM_OPTIONS = boost_program_options-mt
endif
ifeq ($(UNAME), Darwin)
BOOST_PROGRAM_OPTIONS = boost_program_options-mt
endif

all: ezexample_predict ezexample_train library_example recommend

ezexample_predict: ezexample_predict.cc ../vowpalwabbit/libvw.a ezexample.h
	g++ -g -o $@ $< -L ../vowpalwabbit -l vw -l allreduce -l $(BOOST_PROGRAM_OPTIONS) -l z -l pthread

ezexample_train: ezexample_train.cc ../vowpalwabbit/libvw.a ezexample.h
	g++ -g -o $@ $< -L ../vowpalwabbit -l vw -l allreduce -l $(BOOST_PROGRAM_OPTIONS) -l z -l pthread

library_example: library_example.cc ../vowpalwabbit/libvw.a
	g++ -g -o $@ $< -L ../vowpalwabbit -l vw -l allreduce -l $(BOOST_PROGRAM_OPTIONS) -l z -l pthread

recommend: recommend.cc ../vowpalwabbit/libvw.a ezexample.h
	g++ -g -o $@ $< -L ../vowpalwabbit -l vw -l allreduce -l $(BOOST_PROGRAM_OPTIONS) -l z -l pthread

=== vowpalwabbit/Makefile ===
COMPILER = g++
BINARIES = vw active_interactor
MANPAGES = vw.1

all:	
	cd ..; $(MAKE)

test:
	cd ..; $(MAKE) test

things:	config.h $(BINARIES)

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

config.h: ../configure.ac
	echo \#define PACKAGE_VERSION \"`grep AC_INIT ../configure.ac | cut -d '[' -f 3 | cut -d ']' -f 1`\" > config.h

vw_SOURCES = $(shell grep libvw_la_SOURCES Makefile.am | cut -d '=' -f 2)
vw_OBJECTS = $(patsubst %.cc,%.o,$(vw_SOURCES))
vw_DEPS = $(patsubst %.cc,%.d,$(vw_SOURCES))

%.d:	%.cc config.h
	gcc -MM $< > $@

-include $(vw_DEPS)

%.o:	 %.cc  %.h
	$(COMPILER) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(COMPILER) $(FLAGS) -c $< -o $@

liballreduce.a:	allreduce.o
	ar rcs $@ $<

libvw.a: $(filter-out vw.o,$(vw_OBJECTS))
	ar rcs $@ $+

vw: main.o libvw.a liballreduce.a
	$(COMPILER) $(FLAGS) -L$(BOOST_LIBRARY) -L. -o $@ $< -l vw -l allreduce $(LIBS)

active_interactor: active_interactor.cc
	$(COMPILER) $(FLAGS) -o $@ $+

install: $(BINARIES)
	cp $(BINARIES) /usr/local/bin; cd cluster; $(MAKE) install

clean:
	rm -f  *.o *.d $(BINARIES) *~ $(MANPAGES) libvw.a

=== demo/dna/Makefile ===
CXXFLAGS=-O3

.SECONDARY:

all:
	@cat README

clean:
	rm -f $(wildcard dna*.test.predictions dna*.model)

%.check:
	@test -x "$$(which $*)" || {				\
	  echo "ERROR: you need to install $*" 1>&2;		\
	  exit 1;						\
	}

dna_train.%.bz2: wget.check
	wget ftp://largescale.ml.tu-berlin.de/largescale/dna/dna_train.$*.bz2

quaddna2vw: quaddna2vw.cpp

%.model: dna_train.lab.bz2 dna_train.dat.bz2 quaddna2vw paste.check bzcat.check zsh.check
	./do-$*-multicore-train

%.test.predictions: %.model dna_train.lab.bz2 dna_train.dat.bz2 quaddna2vw paste.check bzcat.check zsh.check
	./do-test $< $@

%.perf: %.test.predictions perf.check perl.check zsh.check
	./do-perf $<

=== demo/mnist/Makefile ===
.SECONDARY:
CXXFLAGS=-O3 -Wall

help:
	@cat README

%.check:
	@test -x "$$(which $*)" || {				\
	  echo "ERROR: you need to install $*" 1>&2;		\
	  exit 1;						\
	}

testclean:
	rm -f $(wildcard *.test.predictions)

clean:
	rm -f $(wildcard mnist8mpng.*) $(wildcard mnist8m11png.*) $(wildcard mnist11png.*) $(wildcard mnistpng.*) $(wildcard mnist8m.*) $(wildcard mnist.*)

train8m-%.gz: wget.check
	wget http://ml.nec-labs.com/download/data/mnist8m/train8m-$*.gz

train-%.gz: wget.check
	wget http://yann.lecun.com/exdb/mnist/train-$*.gz

t10k-%.gz: wget.check
	wget http://yann.lecun.com/exdb/mnist/t10k-$*.gz

pixelngrams: pixelngrams.cpp

extractpixels: extractpixels.cpp

extractfeatures: extractfeatures.cpp

%png.model: train-labels-idx1-ubyte.gz train-images-idx3-ubyte.gz extractpixels pixelngrams zsh.check perl.check paste.check
	./do-$*png-train

mnist.model: train-labels-idx1-ubyte.gz train-images-idx3-ubyte.gz extractfeatures zsh.check perl.check paste.check
	./do-mnist-train

mnist8m.model: train8m-labels-idx1-ubyte.gz train8m-images-idx3-ubyte.gz extractfeatures zsh.check perl.check paste.check
	./do-mnist8m-train

%png.test.predictions: %png.model t10k-labels-idx1-ubyte.gz t10k-images-idx3-ubyte.gz zsh.check perl.check paste.check
	./do-pixelngram-test $*png

%.test.predictions: %.model t10k-labels-idx1-ubyte.gz t10k-images-idx3-ubyte.gz zsh.check perl.check paste.check
	./do-test $*

CONFUSION='++$$n; 							\
	   ++$$c if $$F[0] != $$F[1];					\
	   ++$$m{"@{[int($$F[0])]}:$$F[1]"}; } { 			\
	   print "$* test errors: $$c out of $$n";			\
	   print "confusion matrix (rows = truth, columns = prediction):"; \
	   foreach $$true (1 .. 10) {					\
	     print join "\t", map { $$m{"$$true:$$_"} || 0 } (1 .. 10);	\
           }' 

%.test.confusion: %.test.predictions perl.check
	@perl -lane $(CONFUSION) $*.test.predictions

=== debian/changelog ===
vowpal-wabbit (7.3-1ubuntu1) trusty; urgency=low

  * Specify multi-arch boost location.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sun, 27 Oct 2013 01:17:33 +0100

vowpal-wabbit (7.3-1build1) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 18:08:40 +0100

vowpal-wabbit (7.3-1) unstable; urgency=low

  * New upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 27 Aug 2013 20:52:23 -0400

vowpal-wabbit (7.2-1) experimental; urgency=low

  * Fresh upstream release + post-release bugfix for parallel code [3a3ef22]
    - patches up_no_double_allreduce_h, up_remove_allreduce_includes,
      up_ld_vw_against_allreduce,
      changeset_5046679437b058e82e31f42be2a41a70e30e9d7a.diff
      removed (included upstream)
  * debian/watch
    - fixed up for recent changes on github

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 25 Feb 2013 09:46:38 -0500

vowpal-wabbit (7.1-1) experimental; urgency=low

  * New upstream release (Closes: #699020)
    - install active_interactor utility
    - provides core functionality in a dynamic library, thus splitting
      packaging into multiple binary packages
  * debian/copyright
    - updated years
    - added Microsoft Corp to copyright holders
    - expanded BSD-3 license text with disclaimers
  * debian/rules
    - use dh_autoreconf -- upstream uses autotools now for the releases 
    - pass dpkg-buildflags to configure call for hardened builds
  * debian/patches
    - dropped fix-ftbfs-with-gcc-4.7 -- upstream is ready for gcc 4.7
    - CP post-release changeset_5046679437b058e82e31f42be2a41a70e30e9d7a.diff
      to resolve FTBFS
    - added deb_lpthread patch to enforce addition of -lpthread
    - added up_remove_allreduce_includes to avoid exposing all_reduce in libvw
      defined in liballreduce.so, and up_ld_vw_against_allreduce to correctly
      link libvw against allreduce library

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 26 Jan 2013 12:28:24 -0500

=== debian/control ===
Source: vowpal-wabbit
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7.0.50~),
               dh-autoreconf,
               libboost-program-options-dev,
               help2man,
               zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://hunch.net/~vw/
Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git

Package: vowpal-wabbit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Suggests: vowpal-wabbit-doc
Description: fast and scalable online machine learning algorithm
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing

Package: libvw0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast and scalable online machine learning algorithm - dynamic library
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains vowpal-wabbit's dynamic libraries.

Package: libvw-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - development files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains development files needed to compile and link programs
 which use vowpal-wabbit's libraries.

Package: vowpal-wabbit-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, vowpal-wabbit (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - debug files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains debug symbols for the binaries shipped by vowpal-wabbit
 packages.

Package: vowpal-wabbit-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: vowpal-wabbit
Description: fast and scalable online machine learning algorithm - documentation
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains examples (tests) for vowpal-wabbit.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

MANPAGES=vowpalwabbit/vw.1

include /usr/share/dpkg/architecture.mk

%:
	dh  $@  --with autoreconf

%.1: %
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

override_dh_auto_configure:
	dh_auto_configure -- --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) $(shell dpkg-buildflags --export=configure)

override_dh_auto_build:
	dh_auto_build
	debian/rules $(MANPAGES)

override_dh_auto_install:
	dh_auto_install
	: # We generally do not ship .la on Debian systems
	find debian/ -name '*.la' | xargs -r rm -f
	: # We do not patch upstream to not build it (useful to test)
	: # put it makes no sense to install it
	find debian/ -name library_example -delete

override_dh_installexamples:
	dh_installexamples
	: # Change permissions on windows-generated files
	find debian/ -name '*-mswin' -type f | xargs -r chmod a-x

override_dh_auto_test:
	: # I: run tests providing options for verbose output on failures
	cd test && ./RunTests -c -d -f
	: # I: cleaning up after running tests
	find test/ -name '*.tmp' -o -name '*.cache' | xargs -r rm -f
	rm -f test/*.predict

override_dh_auto_clean:
	dh_auto_clean
	-rm -f test/*.predict test/*.tmp depend $(MANPAGES)
	: # And more garbage left with autoreconf
	-rm -f vowpalwabbit/config.h vowpalwabbit/depend

override_dh_strip:
	dh_strip --dbg-package=vowpal-wabbit-dbg

override_dh_compress:
	dh_compress -X.dat -X.predict -X.model -XRunTests

=== debian/watch ===
version=3
opts="filenamemangle=s/.*\/v(.*)/vowpal-wabbit-$1/,uversionmangle=s/rc/~rc/g" \
 https://github.com/JohnLangford/vowpal_wabbit/tags .*archive/v([\d\.a-z]+)\.tar\.gz

## vowpal-wabbit 8.1.1

=== explore/Makefile ===
all:	sample

time:	explore.cpp
	g++ -Wall -O3 explore.cpp -I static -I ../vowpalwabbit -std=c++0x

sample:	explore_sample.cpp
	g++ -Wall -O3 explore_sample.cpp -I static -I ../vowpalwabbit -std=c++0x

=== java/Makefile ===
ifeq ($(JAVA_HOME),)
  $(warning No JAVA_HOME found, JNI building will fail.  Please set JAVA_HOME when using JNI)
  exit 1
endif

VWLIBS := -L../vowpalwabbit -l vw
STDLIBS = $(BOOST_LIBRARY) $(LIBS)
JAVA_INCLUDE = -I $(JAVA_HOME)/include

ifeq ($(UNAME), Linux)
  JAVA_INCLUDE += -I $(JAVA_HOME)/include/linux
endif
ifeq ($(UNAME), FreeBSD)
  JAVA_INCLUDE += -I $(JAVA_HOME)/include/linux
endif
ifeq "CYGWIN" "$(findstring CYGWIN,$(UNAME))"
  JAVA_INCLUDE += -I $(JAVA_HOME)/include/linux
endif
ifeq ($(UNAME), Darwin)
  JAVA_INCLUDE += -I $(JAVA_HOME)/include/darwin
endif

jni_SRCS = $(shell find src/main/c++ -name "*.cc")
jni_OBJS = $(jni_SRCS:.cc=.o)

all:
	cd ..; $(MAKE)

test:
	cd ..; $(MAKE) test

things: pom_version target/vw_jni.lib

pom_version: pom.xml
	ver=$$(grep AC_INIT ../configure.ac | cut -d '[' -f 3 | cut -d ']' -f 1) && \
	newVer=$$(perl -e "@a=split('\.', '$$ver'); \$$a[2]++; print(join('.', @a))") && \
	perl -pi -e "s/(\s*)<version>.*-SNAPSHOT/\1<version>$$newVer-SNAPSHOT/" pom.xml

target/vw_jni.lib: $(jni_OBJS) ../vowpalwabbit/main.o ../vowpalwabbit/libvw.a ../vowpalwabbit/liballreduce.a
	mkdir -p target;
	$(CXX) -shared $(FLAGS) -o $@ $^ $(VWLIBS) $(STDLIBS) $(JAVA_INCLUDE)

%.o: %.cc  %.h
	$(CXX) $(FLAGS) -c $< -o $@ $(JAVA_INCLUDE)

%.o: %.cc
	$(CXX) $(FLAGS) -c $< -o $@ $(JAVA_INCLUDE)

	-include $(jni_SRCS:.cc=.o)

.PHONY: clean
clean:
	rm -f target/vw_jni.lib
	rm -f $(jni_SRCS:.cc=.o)

=== python/Makefile ===
#
# Critical variables are passed recursively (via the environment)
# by the top level Makefile when calling $(MAKE)
#
# If we don't know where to look for boost - it's a no go.
#
#ifeq ($(BOOST_LIBRARY),)
#  $(error Please run 'make' at the top level only)
#endif

PYTHON_VERSION = 2.7
PYTHON_INCLUDE = $(shell python$(PYTHON_VERSION)-config --includes)
PYTHON_LDFLAGS = $(shell python$(PYTHON_VERSION)-config --ldflags)

PYTHON_LIBS = -l boost_python
ifeq (,$(wildcard ../vowpalwabbit/vw.so))
  VWLIBS = ../vowpalwabbit/libvw.a ../vowpalwabbit/liballreduce.a
else
  VWLIBS = -L ../vowpalwabbit -l vw -l allreduce
endif
PYLIBVW = pylibvw.so

all:
	cd ..; $(MAKE) python

things: $(PYLIBVW)

ifeq "CYGWIN" "$(findstring CYGWIN,$(UNAME))"
  PYTHON_LIBS = -l boost_python-mt
  PYLIBVW = pylibvw.dll
endif
ifneq ($(UNAME), Darwin)
  EXPORT_DYNAMIC = -Wl,--export-dynamic
endif

STDLIBS = $(BOOST_LIBRARY) $(LIBS) $(PYTHON_LIBS)

$(PYLIBVW): pylibvw.o  ../vowpalwabbit/libvw.a
	$(CXX) -shared $(EXPORT_DYNAMIC) pylibvw.o $(BOOST_LIBRARY) $(PYTHON_LDFLAGS) $(VWLIBS) $(STDLIBS) -o $(PYLIBVW)

pylibvw.o: pylibvw.cc
	$(CXX) -std=c++0x $(PYTHON_INCLUDE) $(BOOST_INCLUDE) -fPIC -c pylibvw.cc -o pylibvw.o

clean:
	rm -f *.o $(PYLIBVW)

.PHONY: all clean things

=== demo/dependencyparsing/Makefile ===
SHELL=/bin/bash
VW=../../vowpalwabbit/vw
python_exe=python2.7

train_data=wsj_train_subset
test_data=wsj_test_subset
tag=tags

.SECONDARY:

all:
	@cat README.md
clean:
	rm -f *.model *.predictions *.parse *.vw *.cache  *~ *.writing

%.check:
	@test -x "$$(which $*)" || {				\
	  echo "ERROR: you need to install $*" 1>&2;		\
	  exit 1;						\
	}

%.vw: 
	@echo "preprocessing dependency parse data ..." 1>&2
	@echo "Note that due to the licence issue, we only provide a subset of the corpus" 1>&2
	@$(python_exe) parse_data.py $(train_data) $(train_data).vw
	@$(python_exe) parse_data.py $(test_data) $(test_data).vw

dep.model: $(train_data).vw
	@$(VW) --passes 3 -d $< -k -c --search_rollin mix_per_roll --search_task dep_parser --search 12 --search_alpha 1e-5  --search_rollout oracle  --holdout_off -f $@ --search_history_length 3 --search_no_caching -b 30 --root_label 8 --num_label 12 --nn 5 --ftrl

dep.test.predictions: $(test_data).vw dep.model
	@$(VW) -d $< -t $(search_option) -i dep.model -p $@

dep.test.parse: dep.test.predictions
	@$(python_exe) parse_test_result.py $(test_data) $<  $(tag) > $@

dep.perf: dep.test.parse
	@$(python_exe) evaluate.py dep.test.parse $(test_data)

.PHONY: all clean

=== demo/dna/Makefile ===
--- 
+++ 
@@ -27,3 +27,5 @@
 
 %.perf: %.test.predictions perf.check perl.check zsh.check
 	./do-perf $<
+
+.PHONY: all clean

=== demo/entityrelation/Makefile ===
SHELL=/bin/bash
VW=../../vowpalwabbit/vw
search_option=--constraints --search_alpha 1e-8
eval_script=./evaluationER.py

.SECONDARY:

all:
	@cat README.md
clean:
	rm -f *.model *.predictions ER_*.vw *.cache evaluationER.py er.zip *~

%.check:
	@test -x "$$(which $*)" || {				\
	  echo "ERROR: you need to install $*" 1>&2;		\
	  exit 1;						\
	}

er.zip: wget.check unzip.check
	@echo "downloading entity relation data ..." 1>&2
	@wget -q http://web.engr.illinois.edu/~kchang10/data/$@ \

ER_%.vw: er.zip
	@echo "preprocessing entity relation data ..." 1>&2
	@unzip -o $<

er.model: ER_train.vw
	@$(VW) -b 24 -c -d $< --search 10 --passes 10 --search_task entity_relation ${search_option} -f er.model

er.test.predictions: ER_test.vw er.model
	@$(VW) -c -d $< -t -i er.model -p $@

er.perf: ER_test.vw  er.test.predictions python.check
	@$(eval_script)  $< er.test.predictions

.PHONY: all clean

=== demo/mnist/Makefile ===
--- 
+++ 
@@ -3,6 +3,22 @@
 
 help:
 	@cat README
+
+RAW = mnist mnisthogwild mnist8m
+PNG = mnistpng mnist11png mnist8mpng mnist8m11png
+
+raw : $(addsuffix .test.confusion, $(RAW))
+
+png : $(addsuffix .test.confusion, $(PNG))
+
+MNIST = mnist mnisthogwild mnistpng mnist11png
+8M = mnist8m mnist8mpng mnist8m11png
+
+mnist : $(addsuffix .test.confusion, $(MNIST))
+
+mnist8m : $(addsuffix .test.confusion, $(8M))
+
+.PHONY : clean testclean %.test.confusion mnist mnist8m raw png
 
 %.check:
 	@test -x "$$(which $*)" || {				\
@@ -16,8 +32,19 @@
 clean:
 	rm -f $(wildcard mnist8mpng.*) $(wildcard mnist8m11png.*) $(wildcard mnist11png.*) $(wildcard mnistpng.*) $(wildcard mnist8m.*) $(wildcard mnist.*)
 
-train8m-%.gz: wget.check
-	wget http://ml.nec-labs.com/download/data/mnist8m/train8m-$*.gz
+# http://leon.bottou.org/projects/infimnist
+infimnist.tar.gz : wget.check
+	wget http://leon.bottou.org/_media/projects/$@
+
+infimnist : infimnist.tar.gz
+	tar xvfz $<
+	make -C $@
+
+train8m-labels-idx1-ubyte.gz: infimnist
+	(cd infimnist && ./infimnist lab 10000 8109999) | gzip > $@
+
+train8m-images-idx3-ubyte.gz: infimnist
+	(cd infimnist && ./infimnist pat 10000 8109999) | gzip > $@
 
 train-%.gz: wget.check
 	wget http://yann.lecun.com/exdb/mnist/train-$*.gz
@@ -37,6 +64,9 @@
 mnist.model: train-labels-idx1-ubyte.gz train-images-idx3-ubyte.gz extractfeatures zsh.check perl.check paste.check
 	./do-mnist-train
 
+mnisthogwild.model: train-labels-idx1-ubyte.gz train-images-idx3-ubyte.gz extractfeatures zsh.check perl.check paste.check
+	./do-mnist-hogwild-train
+
 mnist8m.model: train8m-labels-idx1-ubyte.gz train8m-images-idx3-ubyte.gz extractfeatures zsh.check perl.check paste.check
 	./do-mnist8m-train
 
@@ -53,7 +83,7 @@
 	   print "confusion matrix (rows = truth, columns = prediction):"; \
 	   foreach $$true (1 .. 10) {					\
 	     print join "\t", map { $$m{"$$true:$$_"} || 0 } (1 .. 10);	\
-           }' 
+           }'
 
 %.test.confusion: %.test.predictions perl.check
 	@perl -lane $(CONFUSION) $*.test.predictions

=== demo/ocr/Makefile ===
# Handwritten words dataset collected by
# Rob Kassel at MIT Spoken Language Systems Group
# http://ai.stanford.edu/~btaskar/ocr/

VW = ../../vowpalwabbit/vw
# same settings as do-mnist-train
VW_OPTS = -b 24 -l 0.1 --nn 40

# http://stackoverflow.com/questions/1541844/joining-elements-of-a-list-in-gnu-make
noop=
space = $(noop) $(noop)
VW_RUN = $(subst $(space),_,$(VW_OPTS))

RM = rm -f
# Python > 2.7 is required
PYTHON = python

help:
	@echo handwritten words dataset collected by
	@echo Rob Kassel at MIT Spoken Language Systems Group
	@echo http://ai.stanford.edu/~btaskar/ocr/
	@echo $$ make run

letter.data.gz:
	wget http://ai.stanford.edu/~btaskar/ocr/letter.data.gz

letter.names:
	wget http://ai.stanford.edu/~btaskar/ocr/letter.names

letter.vw: ocr2vw.py letter.data.gz letter.names
	$(PYTHON) $^ $@ $@.test
	cut -d' ' -f1 $@ | sort | uniq -c | sort -n

# category count
CATN = 26

letter.model_$(VW_RUN): letter.vw
	time $(VW) --oaa $(CATN) --final_regressor $@		\
	  --adaptive --invariant --holdout_off			\
	  --loss_function logistic --passes 14			\
	  $(VW_OPTS) --data $< -k --cache_file $<.cache_$(VW_RUN)
	$(RM) $<.cache_$(VW_RUN)

letter.predictions_$(VW_RUN): letter.model_$(VW_RUN)
	time $(VW) --testonly --initial_regressor $< --predictions $@ \
	  --data letter.vw.test

# taken almost verbatim from ../mnist/Makefile
CONFUSION='++$$n; $$p=int($$F[0]); $$l=ord($$F[1])-ord("a")+1;		\
	   ++$$c if $$p != $$l;						\
	   ++$$m{"$$l:$$p"}; } { 					\
	   print "$* test errors: $$c out of $$n = " .			\
		sprintf("%.2f%%",100*$$c/$$n) .				\
	   	"\nconfusion matrix (rows = truth, columns = prediction):"; \
	   foreach $$true (1 .. $(CATN)) {				\
	     print join "\t", map { $$m{"$$true:$$_"} || 0 } (1 .. $(CATN));	\
           }'

%.confusion_$(VW_RUN): %.predictions_$(VW_RUN)
	@perl -lane $(CONFUSION) $< > $@
	@cat $@

run : letter.confusion_$(VW_RUN)

clean:
	$(RM) letter.*

.PHONY: clean run

=== debian/changelog ===
vowpal-wabbit (8.1.1-1) unstable; urgency=medium

  * Fresh upstream release
  * debian/watch
    - removed 'v' prefix from tags -- upstream stopped using it
  * debian/control
    - added -b debian to the Vcs-Git field
  * debian/rules
    - remove generated by tests files (Closes: #807231). Thanks Chris Lamb
    - force autoconf build system
    - point --with-boost-libdir to /usr/lib/<DEB_HOST_MULTIARCH>
  * debian/patches/deb_lpthread
    - dropped (upstreamed)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 04 May 2014 18:11:52 -0400

vowpal-wabbit (7.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/boost_autoconf.patch: Update Boost autoconf macros to deal
    handle multi-archified Boost. (Closes: #741756)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 25 Apr 2014 23:44:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: vowpal-wabbit
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Yaroslav Halchenko <debian@onerussian.com>
+Maintainer: Yaroslav Halchenko <debian@onerussian.com>
 Build-Depends: debhelper (>= 7.0.50~),
                dh-autoreconf,
                libboost-program-options-dev,
+			   libboost-python-dev,
                help2man,
-               zlib1g-dev
+               zlib1g-dev,
+			   markdown, html2text,
 Standards-Version: 3.9.3
 Homepage: http://hunch.net/~vw/
 Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
-Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git
+Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git -b debian
 
 Package: vowpal-wabbit
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,17 +2,25 @@
 # -*- makefile -*-
 
 MANPAGES=vowpalwabbit/vw.1
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
-include /usr/share/dpkg/architecture.mk
+%: README
+	dh  $@ --buildsystem=autoconf --with autoreconf
 
-%:
-	dh  $@  --with autoreconf
+README: README.md
+	fgrep -v "Status]" $< \
+      | markdown \
+      | html2text -style pretty -nobs \
+      | sed -e 's:&gt;:>:g' \
+      > $@
 
 %.1: %
 	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH) $(shell dpkg-buildflags --export=configure)
+	dh_auto_configure -- \
+      $(shell dpkg-buildflags --export=configure) \
+      --with-boost-libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_auto_build:
 	dh_auto_build
@@ -28,6 +36,10 @@
 
 override_dh_installexamples:
 	dh_installexamples
+	: # Don't ship unreproducible test timings
+	find debian/ -name RunTests.last.times -type f -delete
+	: # Don't ship unreproducible model file
+	find debian/ -name 0001.model -type f -delete
 	: # Change permissions on windows-generated files
 	find debian/ -name '*-mswin' -type f | xargs -r chmod a-x
 
@@ -40,9 +52,12 @@
 
 override_dh_auto_clean:
 	dh_auto_clean
+	-rm -f README
 	-rm -f test/*.predict test/*.tmp depend $(MANPAGES)
 	: # And more garbage left with autoreconf
 	-rm -f vowpalwabbit/config.h vowpalwabbit/depend
+	: # Remove generated makefiles
+	-rm -f Makefile library/Makefile cluster/Makefile vowpalwabbit/Makefile
 
 override_dh_strip:
 	dh_strip --dbg-package=vowpal-wabbit-dbg

=== debian/watch ===
version=3
opts="filenamemangle=s/.*\/(.*)/vowpal-wabbit-$1/,uversionmangle=s/rc/~rc/g" \
 https://github.com/JohnLangford/vowpal_wabbit/tags .*archive/v?(\d[\d\.a-z]+)\.tar\.gz
